PROGRAM MALE;
Uses crt;

Const
   KIR : Array[1..3] of String=('Valge kuninga','Valge lipu','Musta kuninga');

Var X,Y,DX,DY : Array[1..3] of Integer;  { 1 - valge kuningas
                                           2 - valge lipp
                                           3 - must kuningas }
    SIS : String;                        { Abimuutuja }
    A,B : Integer;
{    LU,LV,BU,BV : Integer;}

Function LIPP (U,V:Integer) : Boolean;
{ Kontrollib, kas lipp saab antud väljale käia }
Var LU,LV,BU,BV : Integer;  { Abimuutujad }
Begin
  BU:=U; BV:=V;
  If U > X[2] Then LU:=-1 Else LU:=1;      { Kas antud väli asub lipust }
  If V > Y[2] Then LV:=-1 Else LV:=1;      { par.,vas.,all või ülal     }
  If (U = X[2]) And (V = Y[2]) Then
  Begin
    LIPP:=False;
    Exit;
  End;
  If (V<>Y[2]) And (U<>X[2]) Then          { Kontroll, kas lipp saab    }
  While not ((V=Y[2]) Or (U=X[2])) Do      { antud väljale liikuda      }
  Begin                                    { mööda diagonaali           }
    Inc(U,LU);
    Inc(V,LV);
    If (U=X[1]) And (V=Y[1]) Then          { Kontroll, ega valge kuningas }
    Begin                                  { ei sega                      }
      Lipp:=False;
      Exit;
    End;
  End; { while }
  If (V=Y[2]) And (U=X[2]) Then
    Lipp:=True
  Else
  Begin
    U:=BU; V:=BV;
    If V=Y[2] Then                         { Kas antud väljale saab    }
    While Not (U=X[2]) Do                  { liikuda mööda horisontaali}
    Begin
      Inc(U,LU);
      If (U=X[1]) And (V=Y[1]) Then        { Ega valge kuningas ei sega}
      Begin
        LIPP:=False;
        Exit;
      End;
    End;
    If U=X[2] Then                         { Kas antud väljale saab    }
    While not (V=Y[2]) Do                  { liikuda mööda vertikaali  }
    Begin
      Inc(V,LV);
      If (U=X[1]) And (V=Y[1]) Then        { Ega valge kuningas ei sega}
      Begin
        LIPP:= False;
        Exit;
      End;
    End;
    If (U=X[2]) And (V=Y[2]) Then
      LIPP:=True
    Else
      LIPP:=False;
  End;
End;  { LIPP }

Function KUNINGAS (V,I,J : Integer) : Boolean;
{ Kas kuningas saab käia väljale I, J }
Begin
   If (Abs(X[V]-I) <= 1) And (Abs(Y[V]-J) <= 1) And
      Not ((Abs(X[V]-I) = 0) And (Abs(Y[V]-J) = 0)) Then
      Begin
        KUNINGAS:= True;
        Exit;
      End;
   KUNINGAS:=False;
End; { KUNUNGAS }

Function KUN_KQRVUTI : Boolean;
{ Kontroll, kas kuningad ei asu kõrvuti }
Begin
   If KUNINGAS(1,X[3],Y[3]) Then KUN_KQRVUTI := True
   Else KUN_KQRVUTI:=False;
End; { KUN_KQRVUTI }

Function YHEL_RUUDUL : Boolean;
{ Kontroll, kas mõned nupud ei asu ühel ruudul }
Begin
   If ((X[1]=X[2]) And (Y[1]=Y[2])) Or ((X[2]=X[3]) And (Y[2]=Y[3])) Or
      ((X[1]=X[3]) And (Y[1]=Y[3])) Then YHEL_RUUDUL:=True
   Else
      YHEL_RUUDUL:=False;
End; { YHEL_RUUDUL }

Function KUN_ON_TULES : Boolean;
{ Kontroll, kas must kuningas ei ole lipu tules }
Begin
   If LIPP(X[3],Y[3]) Then KUN_ON_TULES:= True
   Else KUN_ON_TULES:=False;
End; { KUN_ON_TULES }

Function ON_VQIMALIK : Boolean;
{ Kontroll, kas antud seis on võimalik }
Begin
  If KUN_ON_TULES Or KUN_KQRVUTI Or YHEL_RUUDUL Then
     ON_VQIMALIK:=False
  Else
     ON_VQIMALIK:=True;
End; { ON_VQIMALIK }

Function ON_LAUAL : Boolean;
{ Kontroll, kas nupud on üldse laual }
Var I:Integer;
Begin
  ON_LAUAL:=True;
  For I:=1 To 3 Do
    If (Not(X[I] In [1..8])) Or (Not(Y[I] In [1..8])) Then
    Begin
      ON_LAUAL:=False;
      Exit;
    End;
End; { ON_LAUAL }

Function MATT : Boolean;
{ Kontrollib mati tegemise võimalikkust }
Var LX,LY,KX,KY : Integer;  { Abimuutujad }
    KSAAB : Boolean;        { Näitab, kas kuningas saab kuhugi käia }

Begin
   MATT:=False;
   For LX:=1 To 8 Do        { Tsükkel üle terve malelaua }
     For LY:=1 To 8 Do
     Begin
        If LIPP(LX,LY) Then         { Kui lipp saab käia }
        Begin                       { antud väljale       }
           X[2]:=LX; Y[2]:=LY;
           If LIPP(X[3],Y[3]) Then  { Kontrollitakse, kas must }
           Begin                    { kuningas on tule all ja  }
              KSAAB:=False;         { kui on, kas ta saab tule }
              For KX:=1 To 8 Do     { tule alt ära käia       }
                For KY:=1 To 8 Do
                If KUNINGAS (3,KX,KY) And Not(LIPP(KX,KY))
                   And Not(KUNINGAS(1,kx,ky)) Then
                   KSAAB:=True;
              If Not(KSAAB) Then    { Kui must kuningas ei saa }
              Begin                 { kuhugi käia, on matt     }
                 MATT:=True;
                 Exit;
              End;
           End;
           X[2]:=DX[2]; Y[2]:=DY[2];
        End;
     End;
End; { MATT }

BEGIN
ClrScr;
Writeln('Tuleb sisestada valge lipu ja kuninga ning musta');
Writeln('kuninga asukohad malelaual. Programm ütleb, kas ');
Writeln('seis on võimalik ja kas valge saab ühe käiguga');
Writeln('matti teha.');

For A:=1 To 3 Do                     { Sisestamine }
 Begin
    SIS:='';
    Write('Palun ',KIR[A],' asukoht : ');
    Readln(SIS);
    X[A]:=Ord(SIS[1])-Ord('a')+1;
    Val(SIS[2],Y[A],B);
    DX[A]:=X[A];
    DY[A]:=Y[A];
 End;
 Writeln;
 If Not(ON_LAUAL) Then
  Begin
     Writeln('Nupud ei asu laual.');
     Exit;
  End;
 If ON_VQIMALIK Then
  Begin
     If MATT Then
     Writeln('Seis on võimalik ja valge saab käiguga L',
             Chr(Ord('a')+X[2]-1):1,Y[2]:1, ' mustale mati teha.')
     Else
        Writeln('Seis on võimalik, kuid ühe käiguga matti teha ei saa.');
  End
 Else
    Writeln('Selline seis ei ole võimalik.');
End.
